define([
    "dojo/_base/lang",
    "epi/datetime",
    "epi-cms/contentediting/viewmodel/getFriendlyUsername"
], function (
    lang,
    epiDate,
    getFriendlyUsername
) {
    return function (template, username, datetime, capitalizeUsername) {
        // summary:
        //      Return text represent last update time
        // tags:
        //      private

        var date = new Date(datetime);

        return lang.replace(template, {
            username: getFriendlyUsername(username, capitalizeUsername),
            time: epiDate.toUserFriendlyHtml(date),
            timepassed: epiDate.timePassed(date)
        });
    };
});
