define([
    "dojo/when",
    "epi/dependency",
    "epi/shell/applicationSettings",
    "epi-cms/telemetry/trackComponents"
], function (
    when,
    dependency,
    applicationSettings,
    trackComponents
) {
    return {
        initialize: function () {
            if (typeof aptrinsic !== "function") {
                return;
            }

            var telemetry = applicationSettings.telemetry;
            if (!telemetry) {
                return;
            }

            var registry = dependency.resolve("epi.storeregistry");
            var componentsStore = registry.get("epi.shell.component");
            //Initialize Gainsight
            var userFields = {
                id: telemetry.user,
                signUpDate: telemetry.user_creationDate
            };
            var accountFields = {
                id: telemetry.client
            };

            // current using gadgets component
            componentsStore.query({ viewName: "/episerver/cms/home" }).then(function (components) {
                userFields.cms_current_using_gadget = trackComponents.filterCurrentUsingGadgets(components);
            }).always(function () {
                // eslint-disable-next-line no-undef
                aptrinsic("identify",
                    userFields,
                    accountFields
                );
            });

            trackComponents.initialize();
        }
    };
});
