define([
    "dojo/_base/declare",
    "epi-cms/widget/ContentSelector",
    "epi-cms/widget/SelectableMediaComponent"
], function (
    declare,
    ContentSelector,
    SelectableMediaComponent
) {

    return declare([ContentSelector], {
        // summary:
        //      Represents a widget to select Media files.
        // tags:
        //      internal

        // contentClass: [public] String
        //      The content class to be set on the epi-cms/widget/ContentSelectorDialog.
        contentClass: "epi-wrapped epi-mediaSelector",

        // dialogClass: [public] String
        //      The dialog class to be set on the epi-cms/widget/ContentSelectorDialog.
        dialogClass: null,

        // destroyOnHide: [protected] Boolean
        //      Flag which indicates whether the content selector dialog will be destroyed after being hidden.
        //      We can keep the MediaSelector instance alive since it is heavy, it supports paging and only loads
        //      a subset of child content items compared to ContentSelector which loads all children.
        //      The instance will still eventually be destroyed together with the form (for example after changing context
        destroyOnHide: false,

        _setupDialogSettings: function () {
            this.inherited(arguments);
            this.dialogSettings = Object.assign(this.dialogSettings, {
                dialogContentClass: SelectableMediaComponent,
                dialogClass: this.dialogSettings,
                destroyOnHide: this.destroyOnHide
            });
        },

        _setupContentSelectorDialogSettings: function () {
            this.inherited(arguments);
            this.contentSelectorDialogSettings = Object.assign(this.contentSelectorDialogSettings, {
                contentClass: this.contentClass,
                repositoryKey: this.repositoryKey
            });
        }
    });
});
