﻿define([
    // dojo
    "dojo/_base/declare",

    // epi-cms
    "epi-cms/widget/SelectorWrapperBase",
    "epi-cms/widget/MediaSelector",
    "epi-cms/widget/_ContentSelectorActionsMixin",
    "epi-cms/widget/_UrlSelectorMixin"
], function (
    // dojo
    declare,

    // epi-cms
    SelectorWrapperBase,
    MediaSelector,
    _ContentSelectorActionsMixin,
    _UrlSelectorMixin
) {

    return declare([SelectorWrapperBase], {
        // tags:
        //      internal

        selectorClass: declare([MediaSelector, _UrlSelectorMixin, _ContentSelectorActionsMixin], {
            _setupContentSelectorDialogSettings: function () {
                this.inherited(arguments);
                this.contentSelectorDialogSettings = Object.assign(this.contentSelectorDialogSettings, {
                    getCurrentValue: function () {
                        if (this.value && this._convertValueToContentReference(this.value)) {
                            return this._convertValueToContentReference(this.value).createVersionUnspecificReference().toString();
                        }
                        return this.value;
                    }.bind(this)
                });
            }
        }),

        _onSelectorValueChange: function (val) {
            // summary:
            //      Callback whenever selector's value is changed.
            //
            // tags:
            //      protected abstract

            if ((!val && this.value) || (val && this.value !== val)) {
                this.onFocus();
                this.set("value", val);
                this._triggerSave();
            }
        },

        onDrop: function () {
            this._triggerSave();
        }
    });
});
